import javax.swing.JApplet;
import org.nfunk.jep.JEP;

public class CheckInput extends JApplet
{
   private static final long serialVersionUID = 000;
   private JEP myParser;
   
   public void init()
   {
      // Set up the parser (more initialization in parseExpression()) 
      myParser = new JEP();
      myParser.initFunTab(); // clear the contents of the function table
      myParser.setTraverse(true);
      myParser.addStandardFunctions();
      myParser.addStandardConstants();
      myParser.addFunction("max", new Max()); // Add the custom function
      myParser.addFunction("min", new Min()); // Add the custom function
      myParser.addFunction("se", new Conditional()); // Add the custom function
      myParser.addFunction("Se", new Conditional()); // Add the custom function

      myParser.setImplicitMul(true);
      myParser.initSymTab(); // clear the contents of the symbol table
      myParser.addComplex(); // among other things adds i to the symbol table
      myParser.addVariable("c", 0);
   }

   public boolean check(String s) 
   {      
      String expression = s;
      expression = s.toLowerCase();
      expression = expression.replaceAll("sen", "sin"); 
      expression = expression.replaceAll("tg", "tan"); 
      expression = expression.replaceAll("0pi", "0*pi"); 
      expression = expression.replaceAll("1pi", "1*pi"); 
      expression = expression.replaceAll("2pi", "2*pi"); 
      expression = expression.replaceAll("3pi", "3*pi"); 
      expression = expression.replaceAll("4pi", "4*pi"); 
      expression = expression.replaceAll("5pi", "5*pi"); 
      expression = expression.replaceAll("6pi", "6*pi"); 
      expression = expression.replaceAll("7pi", "7*pi"); 
      expression = expression.replaceAll("8pi", "8*pi"); 
      expression = expression.replaceAll("9pi", "9*pi"); 
      expression = expression.replaceAll("pi", "3.14159");
      
      myParser.parseExpression(expression);
      
      System.out.println("Error in expression " + expression + ": " + myParser.hasError()); 
      
      // Get the error information
      if (myParser.getErrorInfo() != null) 
      {
         return false;
      };
      
      return true;
   }
} 
