import java.util.*;
import org.nfunk.jep.*;
import org.nfunk.jep.function.*;
import java.lang.Math;

class Min extends PostfixMathCommand 
{
	public Min() 
	{
		numberOfParameters = 2;
	}
	
	public void run(Stack inStack) throws ParseException 
	{
		// check the stack
		checkStack(inStack);

		// get the parameter from the stack
		Object param2 = inStack.pop();
		Object param1 = inStack.pop();

		// check whether the argument is of the right type
		if ((param1 instanceof Number) && (param2 instanceof Number))
		{
			double y = ((Number)param1).doubleValue();
			double x = ((Number)param2).doubleValue();
			inStack.push(new Double(Math.min(y, x))); //push the result on the inStack
		}
		else
		{
			throw new ParseException("Max(): invalid parameter type");
		}
		
		return;
	}
}

